using BingoBrain.Core;
using BingoBrain.HotFix;

namespace BingoBrain
{
    public class BingoEndUICtrl : BaseUICtrl
    {
        private BingoEndUI ui;
        private BingoEndModel model;

        private uint openUIMsg = SkinInfo.BingoEndUI_Open;
        private uint closeUIMsg = SkinInfo.BingoEndUI_Close;

        #region 生命周期

        protected override void OnInit()
        {
        }

        protected override void OnDispose()
        {
        }

        public override void OpenUI(object args = null)
        {
            if (!BingoCell.IsInGame)
            {
                return;
            }

            if (ui == null)
            {
                ui = new BingoEndUI(this);
                ui.Open(args);
            }
        }

        public override void CloseUI(object args = null)
        {
            if (ui != null && !ui.isClose)
            {
                ui.Close();
            }

            ui = null;
        }

        #endregion

        #region 消息

        public override uint GetOpenUIMsg(string uiName)
        {
            return openUIMsg;
        }

        public override uint GetCloseUIMsg(string uiName)
        {
            return closeUIMsg;
        }

        protected override void AddListener()
        {
            uiCtrlDispatcher.AddListener(openUIMsg, OpenUI);
            uiCtrlDispatcher.AddListener(closeUIMsg, CloseUI);
            gameDispatcher.AddListener(BingoInfo.EndBingoGame, CloseUI);
        }

        protected override void RemoveListener()
        {
            uiCtrlDispatcher.RemoveListener(openUIMsg, OpenUI);
            uiCtrlDispatcher.RemoveListener(closeUIMsg, CloseUI);
        }

        #endregion
    }
}